<template>
  <div>
    <div :class="$style.overview">
      <div :class="$style.customize_select">
        Overview of
        <select name="account" id="account_overview" @change="onChangeAccount">
          <option :value="null" default>all cards</option>
          <option :value="account.id" v-for="account in accounts" :key="account.id">{{ account.name }}</option>
        </select>
      </div>
    </div>
    <div :class="$style.balances">
      <ul :class="$style.balance_ranges" @click="onClickRange">
        <li :class="range === 'Day' ? $style.selected_range : ''">Day</li>
        <li :class="range === 'Week' ? $style.selected_range : ''">Week</li>
        <li :class="range === 'Month' ? $style.selected_range : ''">Month</li>
        <li :class="range === 'Year' ? $style.selected_range : ''">Year</li>
      </ul>
      <div><span>Current balance: {{ totalAmount }}</span></div>
      <div><span>Income: {{ incomeAmount }}</span></div>
      <div><span>Outcome: {{ outcomeAmount }}</span></div>
    </div>
  </div>
</template>

<style module>
.overview {

}

.balances {

}

.customize_select {

}

.balance_ranges {
  display: flex;
  max-width: 100px;
  flex-direction: row;
}

.balance_ranges li {
  list-style-type: none;
  padding: 10px 15px;
  margin: 0 10px;
  border-radius: 50px;
  font-weight: bold;
}

.balance_ranges li:hover {
  background: #edf1fa;
  cursor: pointer;
}

.selected_range {
  color: #5274cb;
  background: #edf1fa;
}
</style>

<script>
import {keyBy, sumBy} from 'lodash';
import 'vue-select/dist/vue-select.css';

// TODO: разделить запросы на получение списка счетов, получение инфы по отдельности для счетов
export default {
  data() {
    return {
      selectedAccount: {
        id: null,
        name: 'All',
      },
      accounts: {},
      range: 'Day',
    };
  },
  computed: {
    totalAmount() {
      if (this.selectedAccount) {
        return this.selectedAccount.total_amount;
      }
      return sumBy(Object.values(this.accounts), account => account.total_amount);
    },
    incomeAmount() {
      if (this.selectedAccount) {
        return this.selectedAccount.income_amount;
      }
      return sumBy(Object.values(this.accounts), account => account.income_amount);
    },
    outcomeAmount() {
      if (this.selectedAccount) {
        return this.selectedAccount.outcome_amount;
      }
      return sumBy(Object.values(this.accounts), account => account.outcome_amount);
    }
  },
  mounted() {
    this.fetchAccounts();
  },
  methods: {
    fetchAccounts(range = 'Day') {
      axios.get('/api/accounts', {
        params: {
          range,
        }
      })
          .then(response => {
            this.accounts = keyBy(response.data.data, 'id');
          })
          .catch(error => {
            console.error(error);
          });
    },
    fetchAccount(accountId, range = 'Day') {
      axios.get(`/api/accounts/${accountId}`, {
        params: {
          range,
        }
      })
          .then(response => {
            this.selectedAccount = response.data.data;
          })
          .catch(error => {
            console.error(error);
          });
    },
    onChangeAccount(event) {
      this.selectedAccount = this.accounts[event.target.value];
      if (this.selectedAccount) {
        this.fetchAccount(this.selectedAccount.id, this.range);
        return;
      }
    },
    onClickRange(event) {
      this.range = event.target.textContent;
      if (event.target.value) {
        this.fetchAccount(this.selectedAccount.id, this.range);
        return;
      }
    },
  }
}
</script>